Option Explicit On 
Imports System.IO

Module modo
    Public Const BYTES As Integer = 192
    Public nBytes As Integer = 192
    Public nSyncCol As Integer = nBytes - 188
    Public sLogFile As String
    Public bLog As Boolean
    Public FURIGANA_SEP_3 As Byte = &HD '&H9
    Public FURIGANA_SEP_4 As Byte = &HA '&H9
    Public FURIGANA_SEP1 As String = "<"
    Public FURIGANA_SEP2 As String = ">"
    Public bӂ肪, b, bCS, bAPS, bPAPF, bCSI, bf[^I[, b^p, bFLC, bHLC, bHLCg, bHTML, b_, bǓ_ As Boolean
    Public bAӂ肪ȉs}~ As Boolean
    Public sӂ肪ȍ, sӂ肪ȉE, s, sCS, sAPS, sPAPF, sPAPFݒl, sCSI, sf[^I[, _
            sFLC, sHLC, sHLCE, so̓R[h, sӂ肪ȃTCY, s_ݒl, sǓ_ݒl, s_, sǓ_ As String
    Public bJ[, b, bJX^J[, bJ[Rg[ As Boolean
    Public bDRCSOo As Boolean
    Public f[^() As Byte
    Public ӂ肪ȃf[^() As Byte
    Public ӂ肪ȈȊOf[^() As Byte
    Public CSIf[^() As Byte
    Public no̓R[h As R[h
    Public nӂ肪ȃTCY As ӂ肪ȃTCY
    Public bӂ肪ȏo As Boolean
    Public bӂ肪ȏo͒ As Boolean
    Public lMidFileLen, lOutFileLen As Long
    Public bPID蓮ݒ As Boolean
    Public bt@CI[v, bOt@CI[v, bԑg񎩓\, bPLLIB\ As Boolean

    Public bʒu As Boolean = False ' True

    Public Const HTML_FURIGANA_L As String = "<sub>"
    Public Const HTML_FURIGANA_R As String = "</sub>"
    Public Const HTML_PRE_L As String = "<pre>"
    Public Const HTML_PRE_R As String = "</pre>"
    Public Const HTML_BR As String = "<br>"
    Public Const HTMLgq As String = ".html"
    Public Const TEXTgq As String = ".txt"
    Public Const HTML_HEAD As String = "<basefont face="""
    Public Const HTML_HEAD_COLOR1 As String = "<body text="""
    Public Const HTML_HEAD_COLOR2 As String = """ bgcolor="""
    Public Const HTML_HEAD_COLOR3 As String = """><basefont face="""
    Public Const HTML_HEAD_R1 As String = """ size="""
    Public Const HTML_HEAD_R2 As String = """>"
    Public Const HTML_FOOT As String = ""
    'Public Const HTML_COLOR_L1 As String = "<font_color="""
    Public Const HTML_COLOR_L1 As String = "</font><font_color="""
    'Public Const HTML_COLOR_L1_OK As String = "<font color="""
    Public Const HTML_COLOR_L1_OK As String = "</font><font color="""
    'Public HTML_COLOR_L1 As String = "<font_style=""background-color:_#808080""><font_color="""
    'Public HTML_COLOR_L1_OK As String = "<font style=""background-color: #808080""><font color="""
    Public HTML_COLOR_L2 As String = """>"
    Public HTML_COLOR_R As String = "</font>"

    Public HTML_HLC_L, HTML_HLC_R As String

    Public Const HTML_HLC_1 As String = "<table_cellspacing=""0""_cellpadding=""0""_border=""1""><tr><td>"
    Public Const HTML_HLC_1_OK As String = "<table cellspacing=""0"" cellpadding=""0"" border=""1""><tr><td>"
    Public Const HTML_HLC_COL1 As String = "<table><tr_bgcolor="""
    Public Const HTML_HLC_COL1_OK As String = "<table><tr bgcolor="""
    Public Const HTML_HLC_COL2 As String = """><td>"
    Public Const HTML_HLC_COL3 As String = "<font_style=""background-color:_"
    Public Const HTML_HLC_COL3_OK As String = "<font style=""background-color: "
    Public Const HTML_HLC_COL4 As String = """_color="""
    Public Const HTML_HLC_COL4_OK As String = """ color="""
    Public Const HTML_HLC_COL5 As String = """>"
    Public Const HTML_HLC_COL6 As String = "</font>"
    Public Const HTML_HLC_2 As String = "</td></tr></table>"

    Public Const sColBG As String = "#404040"
    Public Const sColBK As String = "#000000"
    Public Const sColRD As String = "#FF0000"
    Public Const sColGR As String = "#00FF00"
    Public Const sColYL As String = "#FFFF00"
    Public Const sColBL As String = "#0000FF"
    Public Const sColMG As String = "#FF00FF"
    Public Const sColCN As String = "#00FFFF"
    Public Const sColWH As String = "#FFFFFF"

    Public sCol() As String = New String() _
                            {"#202020", "#800000", "#008000", "#808000", "#000080", "#800080", "#008080", "#404040", "#E0E0E0", "#ffffff", "#000000"}

    'Public bJ[o As Boolean

    Public HTML_HEAD_NO_COLOR As String
    Public HTML_HEAD_COLOR As String

    Public Sp󔒑p As String = ""

    Public bFontHTML As Boolean
    Public sFontHTML As String
    Public sFontSelectHTML As String
    Public nFontSizeHTML As Integer

    Public bԃt@C쐬 As Boolean
    Public BAԃt@C As ArrayList

    Private nACPS_X, nACPS_Y, nACPS_X_WK, nACPS_Y_WK, nӂ肪_Len As Integer
    Private nAPS_X, nAPS_Y, nAPS_X_WK, nAPS_Y_WK As Integer
    Private nAPS_SZ_WK As TCY
    Private nPAPF_X As Integer

    Private Const BUF As Long = 1024

    Private I As Integer
    Private nRPC As Integer

    Private Lenf[^, Lenf[^s As Integer
    Private f[^_NEXT_ADD As Integer
    Private Const f[^_ADD As Integer = 10000

    Private HLCo As Boolean
    Private HLCo As Boolean
    Private HLC_A As Integer

    Public Enum TCY As Byte
        ^ = &H88 'SSZ
        ^ = &H89 'MSZ
        W = &H8A 'NSZ
        {p = &H8B 'SZX
    End Enum

    Private GL As Ăяo
    Private GR As Ăяo
    Private GLSS As Ăяo

    Private G0 As I[
    Private G1 As I[
    Private G2 As I[
    Private G3 As I[

    Private SZ As TCY
    Private SZ_WK As TCY

    Private bARIB As Boolean
    Private bytARIB As Byte
    'Private bFC As Boolean
    'Private bFD As Boolean

    Private LenI, LenR, LenO, LenWK As Long

    Private swLog As System.IO.StreamWriter

    Private Kanji1 As Byte
    'Private bp As Boolean

    Private data_unit_size As Integer
    Private data_size As Integer
    Private adaptationfield_length As Integer
    Private NextDataCol As Integer
    Private StartDataCol, EntDataCol As Integer
    Private bOverData As Boolean
    Private b{ As Boolean

    Public Function ԃt@C쐬(ByVal sInFile As String, ByVal sMidFile As String, _
                    ByVal ProgressBar As ProgressBar, ByVal sbp As StatusBarPanel, ByVal sbpPrc As StatusBarPanel, _
                    ByVal txtPMT_PID As TextBox, ByVal txtPID As TextBox, ByVal txtByte As TextBox) As Boolean
        Dim br As System.IO.FileStream
        Dim PID As Integer

        br = New System.IO.FileStream(sInFile, IO.FileMode.Open, IO.FileAccess.Read, FileShare.ReadWrite)

        LenI = br.Length
        If LenI = 0 Then
            br.Close()
            MsgBox("̓t@C0oCgłB", MsgBoxStyle.Exclamation)
            Return False
        End If

        sbpPrc.Text = "PID擾..."

        Dim PMT_PID As Integer

        PID = PID擾(br, PMT_PID, ProgressBar, sbp)

        If bPID蓮ݒ Then
            If PID = 0 Then br.Close() : Return False
            txtByte.Text = nBytes
            If PID < 0 Then
                PMT_PID = 0
                txtPMT_PID.Text = ""
                PID = -PID
            Else
                txtPMT_PID.Text = Hex(PMT_PID)
            End If
        Else
            If PMT_PID <= 0 Then br.Close() : Return False

            txtByte.Text = nBytes
            txtPMT_PID.Text = Hex(PMT_PID)

            If PID < 0 Then br.Close() : Return False
        End If

        txtPID.Text = Hex(PID)

        sbpPrc.Text = "ԃt@C쐬..."

        If b[h Then
            LenR = Int((br.Length - nobt@ * 1024 * 1024) / nBytes) * nBytes
            If LenR < 0 Then LenR = 0
        Else
            LenR = 0
        End If

        br.Position = LenR
        LenO = 0

        nACPS_X_WK = 0
        nACPS_Y_WK = 0
        nAPS_X_WK = -1
        nAPS_Y_WK = -1

        Dim PID0 As Byte = Int(PID / &H100)
        Dim PID1 As Byte = PID Mod &H100

        Dim bwMid As System.IO.FileStream
        If bԃt@C쐬 Then
            bwMid = New System.IO.FileStream(sMidFile, IO.FileMode.Create, IO.FileAccess.Write, IO.FileShare.ReadWrite)
        Else
            BAԃt@C = New ArrayList
        End If

        ''################################################################################
        'Dim XXX As Integer 'Byte
        'For XXX = 0 To &HFF
        '    bwMid.WriteByte(CByte(XXX))
        'Next
        'For XXX = 0 To &HFF
        '    bwMid.WriteByte(&HA4)
        '    bwMid.WriteByte(CByte(XXX))
        'Next
        'For XXX = 0 To &HFF
        '    bwMid.WriteByte(&HA5)
        '    bwMid.WriteByte(CByte(XXX))
        'Next
        'bwMid.Close()
        'Exit Function
        ''################################################################################

        Dim ByteArray(nBytes * BUF) As Byte
        Dim ByteArrayW(nBytes * BUF) As Byte

        Dim nCount, nCountWk As Integer

        Dim nBytesRead As Integer
        Dim X0 As Byte
        Dim X1 As Byte
        Dim X2 As Byte

        Dim J As Integer = 0
        Dim J_MAX As Integer = 0
        Dim JJ As Integer = 0
        Dim K As Integer = 0

        Do
            If bI Then End 'Exit Function 'End
            nBytesRead = br.Read(ByteArray, 0, nBytes * BUF)
            nCount = LenR * 100 / LenI
            'If nCount > 10 Then Exit Do
            If Not nCount = nCountWk Then
                ProgressBar.Value = IIf(nCount > 100, 100, nCount)
                'ProgressBar.Parent.Refresh()
                sbp.Text = Format(Int(LenR / 1000000), "#,#") & "/" & Format(Int(LenI / 1000000), "#,#" & "MB")
                nCountWk = nCount
                Application.DoEvents()
            End If
            If nBytesRead <= 0 Then Exit Do

            J_MAX = nBytesRead / nBytes - 1
            K = 0

            For J = 0 To J_MAX
                JJ = nBytes * J
                X0 = ByteArray(JJ + nSyncCol)
                X1 = ByteArray(JJ + nSyncCol + 1)
                X2 = ByteArray(JJ + nSyncCol + 2)
                If (X0 = &H47) And _
                        ((X1 Mod &H20) = PID0) And _
                        (X2 = PID1) Then
                    'ReDim Preserve ByteArrayW(K + nBytes - 1)
                    Array.Copy(ByteArray, JJ, ByteArrayW, K, nBytes)
                    K = K + nBytes
                    'For I As Integer = 0 To nBytes - 1
                    '    bwMid.WriteByte(ByteArray(I))
                    'Next
                End If
            Next
            'oCg^z̓eׂď
            If bԃt@C쐬 Then
                bwMid.Write(ByteArrayW, 0, K)
            Else
                Dim b(K - 1) As Byte

                If K > 0 Then
                    Array.Copy(ByteArrayW, 0, b, 0, K)
                    BAԃt@C.AddRange(b)
                End If
            End If
            'bwMid.Write(ByteArray, JJ, nBytes)
            LenR = LenR + nBytes * BUF
        Loop
        'bwMid.Write(ByteArrayW, 0, K)

        sbpPrc.Text = "ԃt@C쐬I"

        br.Close()

        If bԃt@C쐬 Then
            lMidFileLen = bwMid.Length
            bwMid.Close()
            If lMidFileLen = 0 And Not b[h Then
                Dim ret As MsgBoxResult = MsgBox("ԃt@C0oCgłB" & vbNewLine & vbNewLine & _
                        "'" & sMidFile & "' 폜܂H", MsgBoxStyle.YesNo + MsgBoxStyle.Exclamation)
                If ret = MsgBoxResult.Yes Then Kill(sMidFile)
            End If
        Else
            lMidFileLen = BAԃt@C.Count()
        End If

        Return True
    End Function

    Public Function o(ByVal sInFile As String, ByVal sMidFile As String, ByVal sOutFile As String, _
                        ByVal ProgressBar As ProgressBar, ByVal sbp As StatusBarPanel, ByVal sbpPrc As StatusBarPanel, _
                    ByVal txtPID As TextBox, ByVal txtByte As TextBox) As Boolean

        'ByVal bIn As Boolean, ByVal bMid As Boolean, ByVal bOut As Boolean)

        ReDim f[^(1000000)
        ReDim ӂ肪ȃf[^(0)
        ReDim ӂ肪ȈȊOf[^(0)
        ReDim CSIf[^(0)
        Lenf[^ = 0

        Dim br As System.IO.FileStream
        Dim PID As Integer
        'If bIn Then
        '    br = New System.IO.FileStream(sInFile, IO.FileMode.Open, IO.FileAccess.Read)
        '    PID = PID擾(br)
        'ElseIf bMid Then
        '    br = New System.IO.FileStream(sMidFile, IO.FileMode.Open, IO.FileAccess.Read)
        '    PID = ԃt@CPID擾(br)
        'Else
        '    Exit Sub
        'End If

        If bԃt@C쐬 Then
            br = New System.IO.FileStream(sMidFile, IO.FileMode.Open, IO.FileAccess.Read, IO.FileShare.ReadWrite)
            LenI = br.Length
        Else
            LenI = BAԃt@C.Count
        End If

        If LenI = 0 And Not b[h Then
            If bԃt@C쐬 Then br.Close()
            Dim ret As MsgBoxResult = MsgBox("ԃt@C0oCgłB" & vbNewLine & vbNewLine & _
                    "'" & sMidFile & "' 폜܂H", MsgBoxStyle.YesNo + MsgBoxStyle.Exclamation)
            If ret = MsgBoxResult.Yes Then Kill(sMidFile)
            Exit Function
        End If

        sbpPrc.Text = "ԃt@CPID擾..."

        If bԃt@C쐬 Then
            PID = ԃt@CPID擾(br)
            br.Position = 0
        Else
            PID = ԃt@CPID擾()
        End If
        If PID < 0 Then Return False

        txtByte.Text = nBytes
        txtPID.Text = Hex(PID)

        sbpPrc.Text = "ԃt@CǍ..."

        LenR = 0
        LenO = 0
        data_unit_size = 0
        NextDataCol = 0
        StartDataCol = 0
        bOverData = False

        If bLog Then swLog = New System.IO.StreamWriter(sLogFile, _
                False, _
                System.Text.Encoding.GetEncoding(R[h.VtgJIS))

        'MsgBox(Hex(PID))

        If bLog Then
            swLog.WriteLine(">̓t@C")
            swLog.WriteLine(sInFile)
            swLog.WriteLine(">ԃt@C")
            swLog.WriteLine(sMidFile)
            swLog.WriteLine(">t@C")
            swLog.WriteLine(sOutFile)
            swLog.WriteLine()
        End If

        Dim PID0 As Byte = Int(PID / &H100)
        Dim PID1 As Byte = PID Mod &H100

        If GetDataUnit(br, ProgressBar, sbp) Then
            'Dim nD As Integer
            'For nD = 0 To oDataUnit(2).data_unit_size - 1
            '    Debug.Write(Hex(oDataUnit(2).ByteArray(nD)) & " ")
            'Next
            'Stop
        End If

        If oDataUnit.Length <= 1 And Not b[h Then
            If bLog Then
                swLog.Close()
                swLog = Nothing
            End If
            If bԃt@C쐬 Then br.Close()
            br = Nothing
            lOutFileLen = 0
            Return True
        End If

        'Dim bwMid As System.IO.FileStream
        'If bIn And bMid Then
        '    bwMid = New System.IO.FileStream(sMidFile, IO.FileMode.Create, IO.FileAccess.Write)
        'End If
        'Dim bw As New System.IO.FileStream(sOutFile, IO.FileMode.Create, IO.FileAccess.Write)
        Dim bw As New System.IO.StreamWriter(sOutFile, False, System.Text.Encoding.GetEncoding(no̓R[h))

        Dim str As String
        Try   ' Set up structured error handling.

            'Do While srI.Peek >= 0
            '    Dim buff As String
            '    buff = srI.ReadLine()  'Psǂݍ
            'Loop

            'Read 100 bytes into an array from the specified file.
            'Dim nBytes As Integer = 192

            sbpPrc.Text = "t@C쐬..."

            'Dim ByteArray(nBytes) As Byte

            Dim G As Byte
            Dim GG As I[

            Dim nCount, nCountWk As Integer

            GL = Ăяo.G0
            GR = Ăяo.G2
            GLSS = 0

            G0 = I[.
            G1 = I[.p
            G2 = I[.Ђ炪
            G3 = I[.MACRO

            bӂ肪ȏo = False
            bӂ肪ȏo͒ = False
            HLCo = False
            HLCo = False

            If bHTML Then
                If bJ[ Then
                    If bJX^J[ Then
                        HTML_HEAD_COLOR = HTML_HEAD_COLOR1 & sCol(7) & HTML_HEAD_COLOR2 & sCol(8)
                    Else
                        HTML_HEAD_COLOR = HTML_HEAD_COLOR1 & sColWH & HTML_HEAD_COLOR2 & sColBG
                    End If
                    HTML_HEAD_COLOR = HTML_HEAD_COLOR & HTML_HEAD_COLOR3 & sFontSelectHTML & HTML_HEAD_R1 & _
                                        CStr(nFontSizeHTML) & HTML_HEAD_R2
                    WriteString(0, 0, 0, HTML_HEAD_COLOR, True)
                Else
                    HTML_HEAD_NO_COLOR = HTML_HEAD & sFontSelectHTML & HTML_HEAD_R1 & CStr(nFontSizeHTML) & HTML_HEAD_R2
                    WriteString(0, 0, 0, HTML_HEAD_NO_COLOR, True)
                End If
            End If

            If b[h And (LenI = 0 Or oDataUnit.Length <= 1) Then
                If bLog Then
                    swLog.Close()
                    swLog = Nothing
                End If
                If bԃt@C쐬 Then br.Close()
                br = Nothing
                If bHTML Then WriteString(0, 0, 0, HTML_FOOT, True)
                str = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(f[^)
                bw.Write(str)
                bw.Close()
                lOutFileLen = 0
                Return True
            End If

            SetHLCText()

            Dim BA() As Byte
            Dim oD As clsDataUnit
            Dim nData As Integer
            For nData = 1 To UBound(oDataUnit)
                nCount = nData / UBound(oDataUnit) * 100
                If Not nCount = nCountWk Then
                    ProgressBar.Value = IIf(nCount > 100, 100, nCount)
                    sbp.Text = Format(nData, "#,#") & "/" & Format(UBound(oDataUnit), "#,#")
                    nCountWk = nCount
                    Application.DoEvents()
                End If

                oD = Nothing
                oD = oDataUnit(nData)
                If oD.data_unit_parameter = &H30 Then
                    AddGaijiCode(oD)
                ElseIf oD.data_unit_parameter = &H20 Then
                    If bI Then End 'Exit Function 'End
                    GL = Ăяo.G0
                    GR = Ăяo.G2

                    G0 = I[.
                    G1 = I[.p
                    G2 = I[.Ђ炪
                    G3 = I[.MACRO

                    'nCount = LenR * 100 / LenI
                    ''If nCount > 10 Then Exit Do
                    'If Not nCount = nCountWk Then
                    '    ProgressBar.Value = nCount
                    '    ProgressBar.Refresh()
                    '    'Me.Refresh()
                    '    'ProgressBar.Parent.Refresh()
                    '    sbp.Text = Format(Int(LenR / 1000), "#,#") & "/" & Format(Int(LenI / 1000), "#,#" & "KB")
                    '    nCountWk = nCount
                    '    Application.DoEvents()
                    'End If
                    Dim b9B As Boolean
                    b{ = False

                    b9B = False
                    SZ = TCY.W

                    Dim bLS0 As Boolean = False

                    nAPS_X_WK = -1
                    nAPS_Y_WK = -1

                    'Dim BA() As Byte = oD.ByteArray
                    BA = oD.ByteArray
                    EntDataCol = oD.data_unit_size - 1
                    For I = 0 To EntDataCol
                        '1oCgǂݍ
                        Dim X As Integer = BA(I)
                        Dim A As Integer = oD.AddressArray(I)
                        'Debug.WriteLine(Hex(I) & " : " & Hex(X))
                        'If X = &H1F Then Stop
                        'If LenR = 32448 And I = &H7A Then Stop
                        If Not b9B Then
                            If bHLC Then
                                If HLCo Then
                                    HLCo(HLC_A, &H97, &H47)
                                    HLCo = False
                                End If
                            End If
                            If HLCo Then HLCo = False : HLCo = True
                            If bӂ肪 Then
                                Select Case X
                                    Case &H88 'SSZ
                                        LenWK = A
                                        bӂ肪ȏo = True
                                    Case &H89 'MSZ
                                        bӂ肪ȏo = False
                                    Case &H89, &H8A, &H8B 'MSZ, NSZ, SZX
                                        bӂ肪ȏo = False
                                End Select
                            End If
                            Select Case X
                                Case &H8 To &HB
                                    If True Then WriteByte(bw, A, X, &HA1, &HA1) '"@"
                                Case &HC 'CS
                                    'bp = True
                                    'If bCS Then WriteString(bw, A, X, &HD, &HA) 's
                                    If Not SZ = TCY.^ Then
                                        If bCS Then
                                            WriteString(A, X, 0, sCS, True)
                                        Else
                                            WriteLog(A, X, , , , "CS")
                                        End If
                                    Else
                                        WriteLog(A, X, , , , "CS")
                                    End If
                                    b{ = False
                                Case &HF 'LS0
                                    bLS0 = True
                                    GL = Ăяo.G0
                                Case &HE 'LS1
                                    GL = Ăяo.G1
                                Case &H16 'PAPF
                                    If bPAPF Then
                                        Dim Len As Long = Lenf[^s 'UBound(f[^)
                                        If Len > 2 Then
                                            If Not (f[^(Len - 2) = &HD And f[^(Len - 1) = &HA) Then
                                                If SZ = TCY.^ Or bӂ肪ȏo͒ Then
                                                    If bӂ肪 Then
                                                        WriteByte(bw, A, X, &H20) '" "
                                                    Else
                                                        WriteString(A, X, 0, sPAPF, True)
                                                    End If
                                                ElseIf SZ = TCY.^ Then
                                                    'WriteLog(A, X, , , , "PAPF")
                                                    WriteString(A, X, 0, sPAPF, True)
                                                    'WriteByte(bw, A, X, &H20) '" "
                                                Else
                                                    WriteString(A, X, 0, sPAPF, True)
                                                End If
                                            Else
                                                WriteLog(A, X, , , , "PAPF")
                                            End If
                                        Else
                                            WriteLog(A, X, , , , "PAPF")
                                        End If
                                    Else
                                        WriteLog(A, X, , , , "PAPF")
                                    End If
                                    I = I + 1
                                    If bʒu Then
                                        Dim XX As Byte
                                        XX = BA(I)
                                        nPAPF_X = (BA(I) Mod &H40)
                                        WriteString(A, X, XX, sPAPF & StrDup(CInt(Int(nPAPF_X / IIf(SZ = TCY.W, 1, 2))), "@"))
                                        If (Not SZ = TCY.W) Then WriteString(A, X, 0, StrDup(CInt(nPAPF_X Mod 2), " "), True)
                                    End If
                                Case &H1C 'APS
                                    If bAPS Then
                                        Dim Len As Long = Lenf[^s 'UBound(f[^)
                                        If Len > 2 Then
                                            If Not (f[^(Len - 2) = &HD And f[^(Len - 1) = &HA) Then
                                                If SZ = TCY.^ Or bӂ肪ȏo͒ Then
                                                    If bӂ肪 Then
                                                        WriteByte(bw, A, X, &H20) '" "
                                                    Else
                                                        WriteString(A, X, 0, sAPS, True)
                                                    End If
                                                ElseIf SZ = TCY.^ Then
                                                    'WriteLog(A, X, , , , "APS")
                                                    WriteString(A, X, 0, sAPS, True)
                                                    'WriteByte(bw, A, X, &H20) '" "
                                                Else
                                                    WriteString(A, X, 0, sAPS, True)
                                                End If
                                            Else
                                                WriteLog(A, X, , , , "APS")
                                            End If
                                        Else
                                            WriteLog(A, X, , , , "APS")
                                        End If
                                    Else
                                        WriteLog(A, X, , , , "APS")
                                    End If
                                    If bʒu Then
                                        I = I + 1
                                        Dim X2 As Byte = BA(I)
                                        nAPS_Y = (X2 Mod &H40)
                                        I = I + 1
                                        Dim X3 As Byte
                                        X3 = BA(I)
                                        nAPS_X = (X3 Mod &H40)
                                        WriteLog(A, X, X2, , , "APS " & CStr(nAPS_Y) & "s," & CStr(nAPS_X) & "")
                                        'If Not nAPS_Y = nAPS_Y_WK Then
                                        If Not nAPS_Y = nAPS_Y_WK Or ((nAPS_X * IIf(SZ = TCY.W, 2, 1)) < (nAPS_X_WK * IIf(nAPS_SZ_WK = TCY.W, 2, 1)) And nAPS_Y = nAPS_Y_WK) Then
                                            'If Not nAPS_Y = nAPS_Y_WK Or (nAPS_X < nAPS_X_WK And nAPS_Y = nAPS_Y_WK) Then
                                            'If (SZ = TCY.^) Then WriteString(A, X, 0, vbNewLine & vbNewLine, True)
                                            WriteString(A, X, X2, vbNewLine, True)
                                            WriteString(A, X, X2, StrDup(CInt(Int(nAPS_X / IIf(SZ = TCY.W, 1, 2))), "@"), True)
                                            If (Not SZ = TCY.W) Then WriteString(A, X, 0, StrDup(CInt(nAPS_X Mod 2), " "), True)
                                        End If
                                        'WriteString(A, X, 0, StrDup(CInt(BA(I) Mod &H40), IIf(SZ = TCY.W, "@", " ")), True)
                                        'If (SZ = TCY.^) Then WriteString(A, X, 0, vbNewLine, True)
                                        nAPS_X_WK = nAPS_X
                                        nAPS_Y_WK = nAPS_Y
                                        nAPS_SZ_WK = SZ
                                    Else
                                        I = I + 2
                                    End If
                                Case &H19 'SS2
                                    GLSS = Ăяo.G2
                                Case &H1D 'SS3
                                    'GLSS = Ăяo.G3
                                    I = I + 1
                                    X = BA(I)
                                    SetMacro(X)
                                Case &H1B
                                    bLS0 = False
                                    I = I + 1
                                    X = BA(I)
                                    Select Case X
                                        Case &H6E 'LS2
                                            GL = Ăяo.G2
                                        Case &H6F 'LS3
                                            GL = Ăяo.G3
                                        Case &H7E 'LS1R
                                            GR = Ăяo.G1
                                        Case &H7D 'LS2R
                                            GR = Ăяo.G2
                                        Case &H7C 'LS3R
                                            GR = Ăяo.G3
                                            'I = I + 1
                                        Case &H24 '@`C 
                                            I = I + 1
                                            X = BA(I)
                                            Select Case X
                                                Case &H42 '@
                                                    G0 = I[.
                                                Case &H28, &H29, &H2A, &H2B 'A`C
                                                    Select Case X
                                                        Case &H29 'A
                                                            G1 = I[.
                                                        Case &H2A 'B
                                                            G2 = I[.
                                                        Case &H2B 'C
                                                            G3 = I[.
                                                    End Select
                                                    I = I + 1
                                                    Dim XX As Byte = BA(I)
                                                    Select Case XX
                                                        Case &H20 '2byteDRCS
                                                            I = I + 1
                                                            XX = BA(I) + &H80
                                                            Select Case X
                                                                Case &H28
                                                                    G0 = XX
                                                                Case &H29
                                                                    G1 = XX
                                                                Case &H2A
                                                                    G2 = XX
                                                                Case &H2B
                                                                    G3 = XX
                                                            End Select
                                                    End Select
                                                Case Else
                                                    'G0 = X
                                                    G0 = I[.
                                            End Select
                                        Case &H28, &H29, &H2A, &H2B 'D`G
                                            I = I + 1
                                            G = BA(I)
                                            Select Case G
                                                Case &H4A, &H30, &H31
                                                    'Case &H4A 'p
                                                    'Case &H30 'Ђ炪
                                                    'Case &H31 'J^Ji
                                                    Select Case X
                                                        Case &H28 'D
                                                            G0 = G
                                                        Case &H29 'E
                                                            G1 = G
                                                        Case &H2A 'F
                                                            G2 = G
                                                        Case &H2B 'G
                                                            G3 = G
                                                    End Select
                                                Case &H20 '
                                                    I = I + 1
                                                    Dim XX As Byte
                                                    XX = BA(I) + &H80
                                                    Select Case X
                                                        Case &H28
                                                            G0 = XX
                                                        Case &H29
                                                            G1 = XX
                                                        Case &H2A
                                                            G2 = XX
                                                        Case &H2B
                                                            G3 = XX
                                                    End Select
                                            End Select
                                    End Select
                                Case &H1F
                                    Select Case BA(I + 1)
                                        Case Is = &H20
                                            I = I + 4
                                            'CheckLen(ByteArray, I)
                                        Case Is = &H30
                                            I = I + 2
                                            Dim size As Integer = (BA(I) * &H10000 + BA(I + 1) * &H100 + BA(I + 2))
                                            I = I + 2
                                            Dim II As Integer
                                            'Dim oGaiji As New clsGaiji
                                            'ReDim oGaiji.ByteArray(size)
                                            'For II = 0 To size - 1
                                            '    oGaiji.ByteArray(II) = BA(I + II)
                                            'Next
                                            I = I + size
                                        Case Else
                                            I = I + 2
                                            Dim size As Integer = (BA(I) * &H10000 + BA(I + 1) * &H100 + BA(I + 2))
                                            If I + size >= nBytes Then
                                                Exit For
                                            Else
                                                I = I + 2 + size
                                            End If
                                    End Select
                                Case Is < &H20
                                    'I = I + 1
                                    'bw.WriteByte(X)
                                Case &H20
                                    'If BA(I + 1) = &H41 Then
                                    '    I = I + 1
                                    'Else
                                    '    WriteByte(bw, A, X, X)
                                    'End If
                                    WriteByte(bw, A, X, X)
                                    'bw.WriteByte(X)
                                    'Case &H7E
                                    '    I = I + 1
                                    '    If I >= nBytes Then Exit For
                                    '    X = BA(I)
                                    '    If X = &H40 Then
                                    '        I = I + 1
                                    '        If I >= nBytes Then Exit For
                                    '        X = BA(I)
                                    '        If X = &H50 Then
                                    '            I = I + 1
                                    '        End If
                                    '    End If
                                Case Is < &H7F '########## GL ##########
                                    'Debug.WriteLine(Hex(X) & " " & Hex((X + &H80) Mod 256))
                                    'bw.WriteByte((X + &H80) Mod 256)
                                    'If bLS0 Or True Then
                                    '    bw.WriteByte(X + &H80)
                                    'Else
                                    '    bw.WriteByte(&HA5)
                                    '    bw.WriteByte(X + &H80)
                                    'End If
                                    Dim GL_TMP As Ăяo
                                    If GLSS > 0 Then
                                        GL_TMP = GLSS
                                        GLSS = 0
                                    Else
                                        GL_TMP = GL
                                    End If
                                    Select Case GL_TMP
                                        Case Ăяo.G0
                                            GG = G0
                                        Case Ăяo.G1
                                            GG = G1
                                        Case Ăяo.G2
                                            GG = G2
                                        Case Ăяo.G3
                                            GG = G3
                                    End Select
                                    Select Case GG
                                        Case I[.
                                            I = I + 1
                                            Dim X2 As Byte = BA(I)
                                            If (&H20 <= X2 And X2 < &H7F) Then
                                                If CheckKigou2(bw, A, X, X2, X + &H80, X2 + &H80) Then
                                                    WriteByte(bw, A, X, X2, X + &H80, X2 + &H80)
                                                End If
                                            Else
                                                'Stop
                                                WriteLog(A, X, X2, X + &H80, X2, "o")
                                                'If CheckKigou(bw, A, X, X + &H80) Then
                                                '    WriteByte(bw, A, X, X + &H80)
                                                'End If
                                                I = I - 1
                                            End If
                                        Case I[.p
                                            'bp = True
                                            Select Case SZ
                                                Case TCY.W
                                                    Dim sText As String = Chr(X)
                                                    sText = StrConv(sText, VbStrConv.Wide)
                                                    WriteString(A, X, 0, sText, True)
                                                Case Else
                                                    WriteByte(bw, A, X, X)
                                            End Select
                                        Case I[.Ђ炪
                                            If bӂ肪ȏo͒ Then
                                                If CheckKigou(bw, A, X, X + &H80, GG) Then
                                                    WriteByte(bw, A, X, &HA5, X + &H80)
                                                End If
                                            Else
                                                If CheckKigou(bw, A, X, X + &H80, GG) Then
                                                    WriteByte(bw, A, X, &HA4, X + &H80)
                                                End If
                                            End If
                                        Case I[.J^Ji
                                            If CheckKigou(bw, A, X, X + &H80, GG) Then
                                                WriteByte(bw, A, X, &HA5, X + &H80)
                                            End If
                                        Case I[.DRCS_1 To I[.DRCS_15
                                            WriteGaiji(bw, A, GG, X, GG, X)
                                            'WriteByte(bw, A, X, &HB3, &HB0)
                                            'WriteByte(bw, A, X, GG - &H90)
                                            'WriteByte(bw, A, X, &HA5, X + &H80)
                                        Case I[.DRCS_0
                                            WriteLog(A, X, , , , "2byteDRCS")
                                        Case I[.MACRO
                                            If &H60 <= X And X <= &H6F Then
                                                SetMacro(X)
                                            Else
                                                WriteLog(A, X, , , , "MACRO")
                                            End If
                                        Case I[.MosaicA
                                            WriteLog(A, X, , , , "MosaicA")
                                        Case I[.MosaicB
                                            WriteLog(A, X, , , , "MosaicB")
                                        Case I[.MosaicC
                                            WriteLog(A, X, , , , "MosaicC")
                                        Case I[.MosaicD
                                            WriteLog(A, X, , , , "MosaicD")
                                        Case Else
                                            WriteLog(A, X, , , , "I[:0x" & CInt(IIf(X >= &H80, X - &H80, X)).ToString("X"))
                                    End Select
                                Case &H80 'BKF
                                    If bJ[ Then WriteLog(A, X, , , , "BKF")
                                    J[o(A, X)
                                Case &H81 'RDF
                                    If bJ[ Then WriteLog(A, X, , , , "RDF")
                                    J[o(A, X)
                                Case &H82 'GRF
                                    If bJ[ Then WriteLog(A, X, , , , "GRF")
                                    J[o(A, X)
                                Case &H83 'YLF
                                    If bJ[ Then WriteLog(A, X, , , , "YLF")
                                    J[o(A, X)
                                Case &H84 'BLF
                                    If bJ[ Then WriteLog(A, X, , , , "BLF")
                                    J[o(A, X)
                                Case &H85 'MGF
                                    If bJ[ Then WriteLog(A, X, , , , "MGF")
                                    J[o(A, X)
                                Case &H86 'CNF
                                    If bJ[ Then WriteLog(A, X, , , , "CNF")
                                    J[o(A, X)
                                Case &H87 'WHF
                                    If bJ[ Then WriteLog(A, X, , , , "WHF")
                                    J[o(A, X)
                                Case &H88 'SSZ
                                    SetSize(bw, A, X, TCY.^)
                                Case &H89 'MSZ
                                    SetSize(bw, A, X, TCY.^)
                                Case &H8A 'NSZ
                                    SetSize(bw, A, X, TCY.W)
                                Case &H8B 'SZX
                                    I = I + 1
                                    SetSize(bw, A, X, TCY.{p, BA(I))
                                Case &H90 'COL
                                    I = I + 1
                                    Dim X2 As Byte = BA(I)
                                    If X2 = &H20 Then
                                        I = I + 1
                                        If bJ[ Then WriteLog(A, X, X2, , , "COL " & Hex(BA(I)))
                                    ElseIf bJ[ Then
                                        If bJ[Rg[ Then
                                            If (X2 >= &H48 And X2 <= &H4F) Or (X2 >= &H60 And X2 <= &H6F) Then
                                                WriteLog(A, X, X2, , , "COL FG")
                                                J[o(A, (X2 Mod &H8) + &H80)
                                            Else
                                                WriteLog(A, X, X2, , , "COL")
                                            End If
                                        Else
                                            WriteLog(A, X, X2, , , "COL")
                                        End If
                                    End If
                                Case &H91 'FLC
                                    'WriteByte(bw, A, X, &HA1, &HFE) '""
                                    I = I + 1
                                    Dim X2 As Byte = BA(I)
                                    If bFLC And Not (X2 = &H4F) Then
                                        WriteString(A, X, X2, sFLC)
                                    Else
                                        WriteLog(A, X, X2, , , "FLC")
                                    End If
                                Case &H97 'HLC
                                    'WriteByte(bw, A, X, &HA2, &HA2) '""
                                    I = I + 1
                                    Dim X2 As Byte = BA(I)
                                    If X2 = &H47 Then
                                        HLCo = True
                                        HLC_A = A
                                    Else
                                        HLCo(A, X, X2)
                                    End If
                                Case &H98 'RPC
                                    I = I + 1
                                    Dim X2 As Byte = BA(I)
                                    nRPC = (X2 Mod &H40)
                                    WriteLog(A, X, X2, , , "RPC" & nRPC)
                                Case &H9B
                                    If SZ = TCY.^ Then
                                        'bp = True
                                        WriteByte(bw, A, X, &H20)
                                    Else
                                        If b{ Then
                                            If bCSI Then
                                                WriteString(A, X, 0, sCSI, True)
                                            Else
                                                WriteLog(A, X, , , , "CSI")
                                            End If
                                        End If
                                    End If
                                    b9B = True
                                Case &H9D 'TIME
                                    I = I + 1
                                    If BA(I) = &H20 Then
                                        I = I + 1
                                        Dim sWait As String = "[WAIT " & CStr((BA(I) Mod &H40) / 10) & "sec]"
                                        If b Then
                                            WriteString(A, X, &H20, vbNewLine & sWait & vbNewLine)
                                        Else
                                            WriteLog(A, X, &H20, , , sWait)
                                        End If
                                    Else
                                        I = I + 1
                                    End If
                                Case Is <= &H9F
                                    'I = I + 1
                                Case &HF0
                                Case Is <= &HFF '########## GR ##########
                                    Select Case GR
                                        Case Ăяo.G0
                                            GG = G0
                                        Case Ăяo.G1
                                            GG = G1
                                        Case Ăяo.G2
                                            GG = G2
                                        Case Ăяo.G3
                                            GG = G3
                                    End Select
                                    Select Case GG
                                        Case I[.
                                            I = I + 1
                                            Dim X2 As Byte = BA(I)
                                            REM If Not (&HA0 <= X2 And X2 < &HFF) Then Stop
                                            If (&HA0 <= X2 And X2 < &HFF) Then
                                                If CheckKigou2(bw, A, X, X2, X, X2) Then
                                                    WriteByte(bw, A, X, X2, X, X2)
                                                End If
                                            Else
                                                'Stop
                                                WriteLog(A, X, X2, X, X2, "o")
                                                'If CheckKigou(bw, A, X, X) Then
                                                '    WriteByte(bw, A, X, X)
                                                'End If
                                                I = I - 1
                                            End If

                                        Case I[.p
                                            'bp = True
                                            WriteByte(bw, A, X, X - &H80)
                                        Case I[.Ђ炪
                                            If bӂ肪ȏo͒ Then
                                                If CheckKigou(bw, A, X, X, GG) Then
                                                    WriteByte(bw, A, X, &HA5, X)
                                                End If
                                            Else
                                                If CheckKigou(bw, A, X, X, GG) Then
                                                    WriteByte(bw, A, X, &HA4, X)
                                                End If
                                            End If
                                        Case I[.J^Ji
                                            If CheckKigou(bw, A, X, X, GG) Then
                                                WriteByte(bw, A, X, &HA5, X)
                                            End If
                                        Case I[.DRCS_1 To I[.DRCS_15
                                            WriteGaiji(bw, A, GG, X, GG - &H80, X - &H80)
                                            'WriteByte(bw, A, X, &HB3, &HB0)
                                            'bp = True
                                            'WriteByte(bw, A, X, GG - &H80)
                                            'bp = True
                                            'WriteByte(bw, A, X, X - &H60)
                                        Case I[.DRCS_0
                                            WriteLog(A, X, , , , "2byteDRCS")
                                        Case I[.MACRO
                                            WriteLog(A, X, , , , "MACRO")
                                        Case I[.MosaicA
                                            WriteLog(A, X, , , , "MosaicA")
                                        Case I[.MosaicB
                                            WriteLog(A, X, , , , "MosaicB")
                                        Case I[.MosaicC
                                            WriteLog(A, X, , , , "MosaicC")
                                        Case I[.MosaicD
                                            WriteLog(A, X, , , , "MosaicD")
                                        Case Else
                                            WriteLog(A, X, , , , "I[:0x" & CInt(IIf(X >= &H80, X - &H80, X)).ToString("X"))
                                    End Select
                                Case Is < &HFF
                            End Select
                        Else
                            If (X <= &H1F Or (&H80 <= X And X <= &H9F)) Then
                                If X = &H9B Then
                                    b9B = True
                                    ReDim CSIf[^(0)
                                    'ReDim CSIf[^(0)
                                Else
                                    I = I - 1
                                    b9B = False
                                    ReDim CSIf[^(0)
                                End If
                            ElseIf (&H41 <= X And X <= &H7E) Then
                                If bʒu Then
                                    If X = &H61 Then
                                        ReDim Preserve CSIf[^(UBound(CSIf[^) - 1)
                                        Dim sACPS As String = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(CSIf[^)
                                        Dim sACPS_P() As String = Split(sACPS, ";")
                                        If UBound(sACPS_P) > 0 Then
                                            WriteLog(A, X, , , , "ACPS " & sACPS)
                                            'MsgBox(sACPS)
                                            nACPS_X = Val(sACPS_P(0))
                                            nACPS_Y = Val(sACPS_P(1))
                                            If bHTML And bӂ肪ȏo Then WriteString(A, X, 0, HTML_FURIGANA_R, True)
                                            If nACPS_Y > nACPS_Y_WK Or nACPS_X <= nACPS_X_WK Then
                                                'If Not bAӂ肪ȉs}~ And nACPS_X <= nACPS_X_WK Then
                                                '    WriteString(A, X, 0, vbNewLine & StrDup(CInt(Int(nACPS_X / 40)), "@"))
                                                '    WriteString(A, X, 0, StrDup(CInt(Int((nACPS_X Mod 40) / 20)), " "))
                                                'Else
                                                '    WriteString(A, X, 0, vbNewLine)
                                                '    WriteString(A, X, 0, StrDup(CInt(Int(nACPS_X / 40)), "@"))
                                                '    WriteString(A, X, 0, StrDup(CInt(Int((nACPS_X Mod 40) / 20)), " "))
                                                'End If
                                                WriteString(A, X, 0, vbNewLine)
                                                WriteString(A, X, 0, StrDup(CInt(Int(nACPS_X / 40)), "@"))
                                                WriteString(A, X, 0, StrDup(CInt(Int((nACPS_X Mod 40) / 20)), " "))
                                            Else
                                                'WriteString(A, X, 0, vbNewLine)
                                                WriteString(A, X, 0, vbNewLine & StrDup(CInt(Int(nACPS_X / 40)), "@"))
                                                'nACPS_X = nACPS_X - nACPS_X_WK '- (nӂ肪_Len * 20)
                                                'If nACPS_X <= 0 Then nACPS_X = 20
                                                'WriteString(A, X, 0, StrDup(CInt(Int(nACPS_X / 40)), "@"))
                                                WriteString(A, X, 0, StrDup(CInt(Int((nACPS_X Mod 40) / 20)), " "))
                                            End If
                                            'MsgBox(Int((nACPS_X Mod 40) / 20))
                                            If bHTML And bӂ肪ȏo Then WriteString(A, X, 0, HTML_FURIGANA_L, True)
                                            nACPS_X_WK = nACPS_X
                                            nACPS_Y_WK = nACPS_Y
                                        Else
                                            Debug.WriteLine("-" & sACPS)
                                        End If

                                        b9B = False
                                        ReDim CSIf[^(0)
                                    End If
                                Else
                                    b9B = False
                                    ReDim CSIf[^(0)
                                End If
                            ElseIf (&H30 <= X And X <= &H39 Or X = &H3B) Then
                                WriteCSIf[^(X)
                            End If
                        End If
                    Next
                End If
                'If Not (oD.data_unit_size = 1 And oD.ByteArray(oD.data_unit_size - 1) = &HC) Then
                If Not (oD.data_unit_size = 1 And oD.ByteArray(oD.data_unit_size - 1) = &HC) Then
                    If bf[^I[ Then
                        WriteString(oD.AddressArray(oD.data_unit_size - 1), oD.ByteArray(oD.data_unit_size - 1), 0, sf[^I[, True)
                    Else
                        WriteLog(oD.AddressArray(oD.data_unit_size - 1), , , , , "f[^I[")
                    End If
                End If
            Next

            If bHTML Then WriteString(oD.AddressArray(oD.data_unit_size - 1) + 1, 0, 0, HTML_FOOT, True)

            ReDim Preserve f[^(Lenf[^ - 1) 'UBound(f[^) - 1)
            str = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(f[^)
            str = ReplaceARIBGaiji(str)
            'If bӂ肪 Then str = Replace(str, "< >" & vbNewLine, "") '07/08/15

            'Aӂ肪ȉs}~
            If bӂ肪 And bAӂ肪ȉs}~ Then
                If bHTML Then
                    str = Replace(str, sӂ肪ȉE & HTML_FURIGANA_R & vbNewLine & HTML_FURIGANA_L & sӂ肪ȍ, _
                                sӂ肪ȉE & "@")
                Else
                    If Not (Trim(sӂ肪ȍ) = "" Or Trim(sӂ肪ȉE) = "") Then
                        str = Replace(str, sӂ肪ȉE & vbNewLine & sӂ肪ȍ, sӂ肪ȉE & "  " & sӂ肪ȍ)
                    End If
                End If
            End If

            'HTMLs
            If bHTML Then
                If bJ[ Then
                    str = HTML_HEAD_COLOR & Replace(str, " ", "&nbsp;", Strings.Len(HTML_HEAD_COLOR) + 1, , CompareMethod.Binary)
                    str = Replace(str, vbNewLine, HTML_BR & vbNewLine)
                    str = HTML_HEAD_COLOR & Replace(str, HTML_COLOR_L1, HTML_COLOR_L1_OK, Strings.Len(HTML_HEAD_COLOR) + 1)
                Else
                    str = HTML_HEAD_NO_COLOR & Replace(str, " ", "&nbsp;", Strings.Len(HTML_HEAD_NO_COLOR) + 1, , CompareMethod.Binary)
                    str = Replace(str, vbNewLine, HTML_BR & vbNewLine)
                End If
                str = ReplaceHLCText(str)
            End If

            bw.Write(str)

        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try

        'Xg[
        If bLog Then swLog.Close() : swLog = Nothing
        If bԃt@C쐬 Then br.Close()
        bw.Close()

        lOutFileLen = Len(str)
        If lOutFileLen = 0 And Not b[h Then
            Dim ret As MsgBoxResult = MsgBox("t@C0oCgłB" & vbNewLine & vbNewLine & _
                    "'" & sOutFile & "' 폜܂H", MsgBoxStyle.YesNo + MsgBoxStyle.Exclamation)
            If ret = MsgBoxResult.Yes Then Kill(sOutFile)
        End If

        bw = Nothing
        br = Nothing

        Return True
    End Function

    Private Function CheckKigou(ByVal bw As System.IO.StreamWriter, ByVal A As Integer, ByVal RX As Byte, ByVal X As Byte, _
                                Optional ByVal GG As I[ = I[.p) As Boolean
        If Not bӂ肪 And SZ = TCY.^ Then
            'bFC = False
            'bFD = False
            Exit Function
        End If

        'Case &HA1
        '    If bFC Then
        '        bFC = False
        '        If b Then WriteByte(bw, A, X, &HA2, &HCD) '""
        '    Else
        '        Return True
        '    End If

        'If GG = I[.p Then Return True

        Select Case X
            Case &HF7
                Select Case GG
                    Case I[.Ђ炪
                        WriteByte(bw, A, RX, &HA1, &HB5) '"T"
                    Case I[.J^Ji
                        WriteByte(bw, A, RX, &HA1, &HB3) '"R"
                    Case Else
                        Return True
                End Select
            Case &HF8
                Select Case GG
                    Case I[.Ђ炪
                        WriteByte(bw, A, RX, &HA1, &HB6) '"U"
                    Case I[.J^Ji
                        WriteByte(bw, A, RX, &HA1, &HB4) '"S"
                    Case Else
                        Return True
                End Select
            Case &HF9
                WriteByte(bw, A, RX, &HA1, &HBC) '"["
            Case &HFA
                WriteByte(bw, A, RX, &HA1, &HA3) '"B"
                If b_ Then WriteString(A, X, 0, s_, True)
            Case &HFB
                WriteByte(bw, A, RX, &HA1, &HD6) '"u"
                'If SZ = TCY.^ Then
                '    WriteByte(bw, A, RX, &HA1, &HD6) '"u"
                'Else
                '    Return True
                'End If
            Case &HFC
                WriteByte(bw, A, RX, &HA1, &HD7) '"v"
                'If SZ = TCY.^ Then
                '    WriteByte(bw, A, RX, &HA1, &HD7) '"v"
                'Else
                '    Return True
                'End If
            Case &HFD
                WriteByte(bw, A, RX, &HA1, &HA2) '"A"
                If bǓ_ Then WriteString(A, X, 0, sǓ_, True)
            Case &HFE
                WriteByte(bw, A, RX, &HA1, &HA6) '"E"
            Case Else
                Return True
        End Select
        Return False
    End Function

    Private Function CheckKigou2(ByVal bw As System.IO.StreamWriter, ByVal A As Integer, ByVal RX1 As Byte, ByVal RX2 As Byte, _
                                 ByVal X1 As Byte, ByVal X2 As Byte) As Boolean
        If Not bӂ肪 And SZ = TCY.^ Then
            Return False
        End If

        If X1 = &HFC And X2 = &HA1 Then
            If Not b Then
                WriteLog(A, RX1, RX2, , , "")
                Return False
                'WriteByte(bw, A, X, &HA2, &HCD) '""
            End If
            If Not (s = "ARIBO" Or sFontSelectHTML = WIN_DVD_FONT Or sFontSelectHTML = RICHO_FONT) Then
                WriteString(A, RX1, RX2, s)
                Return False
            End If
        End If

        Select Case X1
            Case &HFA To &HFE
                Select Case X2
                    Case &H91 To &HFE
                        WriteARIBGaiji(A, RX1, RX2, X1, X2)
                        Return False
                End Select
        End Select
        Return True
    End Function

    'Private Function CheckKigou2_0(ByVal bw As System.IO.StreamWriter, ByVal A As Integer, ByVal X As Byte) As Boolean
    '    If Not bӂ肪 And SZ = TCY.^ Then
    '        'bFC = False
    '        'bFD = False
    '        Exit Function
    '    End If

    '    Select Case X
    '        Case &HA1
    '            If bARIB And bytARIB = &HFC Then
    '                bARIB = False
    '                If Not b Then Exit Function 'WriteByte(bw, A, X, &HA2, &HCD) '""
    '            End If
    '    End Select

    '    Select Case X
    '        Case &H91 To &HFE
    '            'If GL = G0 Then
    '            If bARIB Then
    '                bARIB = False
    '                WriteARIBGaiji(bw, A, bytARIB, X)
    '                Return False
    '            End If
    '            'End If
    '    End Select

    '    Select Case X
    '        Case &HFA To &HFE
    '            If Kanji1 = 0 Then
    '                bARIB = True
    '                bytARIB = X
    '                Return False
    '            Else
    '                Return True
    '            End If
    '        Case Else
    '            bARIB = False
    '            Return True
    '    End Select

    '    'Select Case X
    '    '    Case &HEE
    '    '        If bFD Then
    '    '            bFD = False
    '    '            WriteByte(bw, A, X, &H21, &H21) '"!!"
    '    '        Else
    '    '            Return True
    '    '        End If
    '    '    Case &HEF
    '    '        If bFD Then
    '    '            bFD = False
    '    '            WriteByte(bw, A, X, &H21, &H3F) '"!?"
    '    '        Else
    '    '            Return True
    '    '        End If
    '    '    Case &HA1
    '    '        If bFC Then
    '    '            bFC = False
    '    '            If b Then WriteByte(bw, A, X, &HA2, &HCD) '""
    '    '        Else
    '    '            Return True
    '    '        End If
    '    '    Case &HF8
    '    '        If bFD Then
    '    '            bFD = False
    '    '            WriteByte(bw, A, X, &HA2, &HE4) '""
    '    '        Else
    '    '            Return True
    '    '        End If
    '    '    Case &HF9
    '    '        If bFD Then
    '    '            bFD = False
    '    '            WriteByte(bw, A, X, &HA2, &HE3) '""
    '    '        Else
    '    '            Return True
    '    '        End If
    '    '    Case &HFA
    '    '        If bFD Then
    '    '            bFD = False
    '    '            WriteByte(bw, A, X, &HA2, &HF6) '""
    '    '        Else
    '    '            Return True
    '    '        End If
    '    '    Case &HFB
    '    '        If SZ = TCY.^ Then
    '    '            WriteByte(bw, A, X, &HA1, &HD6) '"u"
    '    '        Else
    '    '            Return True
    '    '        End If
    '    '    Case &HFC
    '    '        If SZ = TCY.^ Then
    '    '            WriteByte(bw, A, X, &HA1, &HD7) '"v"
    '    '        Else
    '    '            bFC = True
    '    '        End If
    '    '    Case &HFD
    '    '        bFD = True
    '    '    Case Else
    '    '        Return True
    '    'End Select
    '    Return False
    'End Function

    'Private Sub WriteByte(ByVal bw As System.IO.StreamWriter, ByVal I As Integer, ByVal RX As Byte, ByVal WX As Byte)
    '    Dim X(1) As Byte
    '    Dim S As String

    '    If Not bӂ肪 And SZ = TCY.^ Then
    '        Exit Sub
    '    End If

    '    Writef[^(WX)

    '    X(0) = WX
    '    S = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(X) 'EUC

    '    WriteLog(I, RX, , WX, , S)

    '    LenO = LenO + 1

    '    b{ = True
    'End Sub

    'Private Sub WriteByte(ByVal bw As System.IO.StreamWriter, ByVal I As Integer, ByVal RX1 As Byte, ByVal RX2 As Byte, ByVal WX As Byte)
    Private Sub WriteByte(ByVal bw As System.IO.StreamWriter, ByVal I As Integer, ByVal RX1 As Byte, ByVal WX As Byte)
        For nR As Integer = nRPC To 2 Step -1
            nRPC = 0
            WriteByte(bw, I, RX1, WX)
        Next nR

        Dim X(1) As Byte
        Dim S As String

        If Not bӂ肪 And SZ = TCY.^ Then
            Exit Sub
        End If

        Dim bRet As Boolean = Writef[^(WX)

        X(0) = WX
        S = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(X) 'EUC

        WriteLog(I, RX1, , WX, , S)

        If bRet Then LenO = LenO + 1

        b{ = True
    End Sub

    Private Sub WriteByte(ByVal bw As System.IO.StreamWriter, ByVal I As Integer, ByVal RX1 As Byte, _
                          ByVal WX1 As Byte, ByVal WX2 As Byte)
        For nR As Integer = nRPC To 2 Step -1
            nRPC = 0
            WriteByte(bw, I, RX1, WX1, WX2)
        Next nR

        Dim X(1) As Byte
        Dim S As String

        If Not bӂ肪 And SZ = TCY.^ Then
            Exit Sub
        End If

        If (WX1 = &HD And WX2 = &HA) Then
            Dim Len As Long = Lenf[^s 'UBound(f[^)
            If Len >= 2 Then
                If f[^(Len - 2) = &HD And f[^(Len - 1) = &HA Then
                    WriteLog(I, RX1, , , , )
                    b{ = True
                    Exit Sub
                Else
                    'If bJ[ And bJ[o Then bJ[o = False : WriteString(I, RX1, 0, HTML_COLOR_R, False)
                End If
            End If
            X(0) = 0
        End If

        X(0) = WX1
        If (WX1 = &HD And WX2 = &HA) Then
            X(0) = 0
        Else
            X(1) = WX2
            'X(2) = &HD
        End If
        'X(3) = &HA

        S = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(X)  'EUC
        If b^p And SZ = TCY.^ Then
            S = StrConv(S, VbStrConv.Narrow)
            X = System.Text.Encoding.GetEncoding(R[h.EUC).GetBytes(S)
            WriteString(I, RX1, 0, S, True)
            Exit Sub
        End If

        Dim bRet1 As Boolean = Writef[^(WX1)
        Dim bRet2 As Boolean = Writef[^(WX2)

        WriteLog(I, RX1, , WX1, WX2, S)

        If bRet1 Then LenO = LenO + 1
        If bRet2 Then LenO = LenO + 1

        b{ = True
    End Sub

    Private Sub WriteByte(ByVal bw As System.IO.StreamWriter, ByVal I As Integer, ByVal RX1 As Byte, ByVal RX2 As Byte, _
                          ByVal WX1 As Byte, ByVal WX2 As Byte)
        For nR As Integer = nRPC To 2 Step -1
            nRPC = 0
            WriteByte(bw, I, RX1, RX2, WX1, WX2)
        Next nR

        Dim X(1) As Byte
        Dim S As String

        If (WX1 = &HD And WX2 = &HA) Then
            Dim Len As Long = Lenf[^s 'UBound(f[^)
            If Len >= 2 Then
                If f[^(Len - 2) = &HD And f[^(Len - 1) = &HA Then
                    WriteLog(I, RX1, RX2, , , )
                    b{ = True
                    Exit Sub
                Else
                    'If bJ[ And bJ[o Then bJ[o = False : WriteString(I, RX1, RX2, HTML_COLOR_R)
                End If
            End If
        End If

        X(0) = WX1
        X(1) = WX2

        S = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(X)  'EUC
        If b^p And SZ = TCY.^ Then
            S = StrConv(S, VbStrConv.Narrow)
            X = System.Text.Encoding.GetEncoding(R[h.EUC).GetBytes(S)
            WriteString(I, RX1, 0, S, True)
            Exit Sub
        End If

        Dim bRet1 As Boolean = Writef[^(WX1)
        Dim bRet2 As Boolean = Writef[^(WX2)

        WriteLog(I, RX1, RX2, WX1, WX2, S)

        If bRet1 Then LenO = LenO + 1
        If bRet2 Then LenO = LenO + 1
        b{ = True
    End Sub

    Private Sub WriteString(ByVal I As Integer, ByVal RX1 As Byte, ByVal RX2 As Byte, ByVal sText As String, _
                            Optional ByVal b1Byte As Boolean = False, Optional ByVal bs`FbN As Boolean = False)
        For nR As Integer = nRPC To 2 Step -1
            nRPC = 0
            WriteString(I, RX1, RX2, sText, b1Byte)
        Next nR

        Dim X(1) As Byte
        Dim S As String

        Dim J As Integer
        For J = 1 To Len(sText)
            S = Mid(sText, J, 1)
            X = System.Text.Encoding.GetEncoding(R[h.EUC).GetBytes(S) 'EUC

            If Len(sText) = 2 Then
                Dim X2 = System.Text.Encoding.GetEncoding(R[h.EUC).GetBytes(Mid(sText, 2, 1))
                If X(0) = &HD And X2(0) = &HA Then
                    Dim Len As Long = Lenf[^s 'UBound(f[^)
                    If Len >= 2 Then
                        If f[^(Len - 2) = &HD And f[^(Len - 1) = &HA Then
                            WriteLog(I, RX1, RX2, , , "s}~")
                            b{ = True
                            Exit Sub
                        Else
                            'If bJ[ And bJ[o Then bJ[o = False : WriteString(I, RX1, RX2, HTML_COLOR_R, b1Byte)
                        End If
                    End If
                End If
            ElseIf Len(sText) = 4 Then
                Dim X2 = System.Text.Encoding.GetEncoding(R[h.EUC).GetBytes(Mid(sText, 2, 1))
                Dim X3 = System.Text.Encoding.GetEncoding(R[h.EUC).GetBytes(Mid(sText, 3, 1))
                Dim X4 = System.Text.Encoding.GetEncoding(R[h.EUC).GetBytes(Mid(sText, 4, 1))
                If X(0) = &HD And X2(0) = &HA And X3(0) = &HD And X4(0) = &HA Then
                    Dim Len As Long = Lenf[^s 'UBound(f[^)
                    If Len >= 4 Then
                        If f[^(Len - 4) = &HD And f[^(Len - 3) = &HA And _
                                f[^(Len - 2) = &HD And f[^(Len - 1) = &HA Then
                            WriteLog(I, RX1, RX2, , , "s}~")
                            b{ = True
                            Exit Sub
                        Else
                            'If bJ[ And bJ[o Then bJ[o = False : WriteString(I, RX1, RX2, HTML_COLOR_R, b1Byte)
                        End If
                    End If
                End If
            End If

            Select Case UBound(X)
                Case 0
                    If X(0) = &HD Then S = "CR"
                    If X(0) = &HA Then S = "LF"

                    Dim bRet1 As Boolean = Writef[^(X(0), bs`FbN)

                    If b1Byte Then
                        WriteLog(I, RX1, , X(0), , S)
                    Else
                        WriteLog(I, RX1, RX2, X(0), , S)
                    End If

                    If bRet1 Then LenO = LenO + 1
                Case 1
                    Dim bRet1 As Boolean = Writef[^(X(0), bs`FbN)
                    Dim bRet2 As Boolean = Writef[^(X(1), bs`FbN)

                    If b1Byte Then
                        WriteLog(I, RX1, , X(0), X(1), S)
                    Else
                        WriteLog(I, RX1, RX2, X(0), X(1), S)
                    End If

                    If bRet1 Then LenO = LenO + 1
                    If bRet2 Then LenO = LenO + 1
            End Select
        Next

        b{ = True
    End Sub

    Private Sub WriteARIBGaiji(ByVal I As Integer, ByVal RX1 As Byte, ByVal RX2 As Byte, _
                               ByVal X1 As Byte, ByVal X2 As Byte)
        If Not bARIBOo Then
            WriteLog(I, X1, X2)
            Exit Sub
        End If

        Dim X() As Byte
        Dim uARIBTmp As ARIB
        Dim S As String
        Dim nCode As Integer = ((X1 - &HA0) * 100 + X2 - &HA0)

        uARIBTmp = uARIB(nCode - 9000)
        uARIB(nCode - 9000).Used = True

        If Not uARIBTmp.Output Then
            WriteLog(I, RX1, RX2)
            Exit Sub
        End If

        'Dim sGaiji As String = uARIBTmp.Text

        'If sGaiji = "" Then sGaiji = "[O" & CStr(nCode) & "]"

        Dim sGaiji As String = "[O" & CStr(nCode) & "]"

        WriteString(I, RX1, RX2, sGaiji)
    End Sub

    Private Sub WriteGaiji(ByVal bw As System.IO.StreamWriter, ByVal I As Integer, ByVal RGG As I[, ByVal RX As Byte, _
                           ByVal GG As I[, ByVal WX As Byte)
        Dim X() As Byte
        Dim sGaiji As String = GetGaiji(GG * &H100 + WX)

        If Not bDRCSOo Or (sGaiji = "") Then
            WriteLog(I, RGG, RX)
            Exit Sub
        End If

        WriteString(I, RGG, RX, sGaiji)
    End Sub

    Private Sub WriteLog(ByVal I As Integer, Optional ByVal RX1 As Integer = -1, Optional ByVal RX2 As Integer = -1, _
                           Optional ByVal WX1 As Integer = -1, Optional ByVal WX2 As Integer = -1, _
                           Optional ByVal C As String = "")
        If Not bLog Then Exit Sub

        Dim S, sI, sRX1, sRX2, sWX1, sWX2, sLen0 As String

        sI = Hex0(I, 4)
        sRX1 = IIf(RX1 = -1, "  ", Hex0(RX1, 2))
        sRX2 = IIf(RX2 = -1, "  ", Hex0(RX2, 2))
        sWX1 = IIf(WX1 = -1, "  ", Hex0(WX1, 2))
        sWX2 = IIf(WX2 = -1, "  ", Hex0(WX2, 2))
        sLen0 = Hex0(LenO, 4)
        S = "> " & sI & " # " & sRX1 & " " & sRX2 & " # " & sWX1 & " " & sWX2 & " > " & sLen0 & " " & C

        'Debug.WriteLine(S)
        swLog.WriteLine(S)
    End Sub

    Function CheckLen(ByVal ByteArray() As Byte, ByRef I As Integer)
        I = I + 2
        data_unit_size = ByteArray(I) * &H10000 + ByteArray(I + 1) * &H100 + ByteArray(I + 2)
        I = I + 2
        If data_unit_size > (nBytes - 2 - I) Then
            bOverData = True
            NextDataCol = nBytes * 2 - I - data_unit_size - 3
        End If
    End Function

    Sub SetSize(ByVal bw As System.IO.StreamWriter, ByVal A As Integer, ByVal X As Byte, ByVal SZ_NEW As TCY, Optional ByVal X2 As Byte = 0)
        If bӂ肪 Then
            If bӂ肪ȏo͒ Then
                If ((Not (SZ_WK = TCY.^) And (SZ_NEW = TCY.^))) Then    '^ȊO^
                    b{ = False
                ElseIf ((SZ_WK = TCY.^) And (Not (SZ_NEW = TCY.^))) Then    '^^ȊO
                    'b{ = False
                    WriteString(A, X, 0, sӂ肪ȉE, True)
                    WriteByte(bw, A, X, FURIGANA_SEP_3, FURIGANA_SEP_4)
                    bӂ肪ȏo͒ = False
                End If
            Else
                If ((Not (SZ_WK = TCY.^) And (SZ_NEW = TCY.^))) Then    '^ȊO^
                ElseIf ((SZ_WK = TCY.^) And (Not (SZ_NEW = TCY.^))) Then    '^^ȊO
                    nӂ肪_Len = UBound(ӂ肪ȃf[^)
                    If nӂ肪_Len > 0 Then
                        bӂ肪ȏo = False
                        Dim sText As String = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(ӂ肪ȃf[^)
                        sText = Replace(sText, vbNullChar, "")
                        ReDim ӂ肪ȃf[^(0)
                        'Debug.WriteLine(sText & "|")
                        Dim sTmp As String = Replace(Trim(sText), vbNewLine, "")
                        If Trim(sText) = "" Then   'ӂ肪Ȃ
                            'Stop
                        Else
                            'MsgBox("|" & sText & "|")
                            A = LenWK
                            'MsgBox(LenR & "," & LenWK)
                            If Not bʒu Then sText = Trim(sText)

                            Select Case nӂ肪ȃTCY
                                Case ӂ肪ȃTCY.Sp
                                Case ӂ肪ȃTCY.p
                                    sText = Replace(sText, "@", Sp󔒑p)
                                    sText = StrConv(sText, VbStrConv.Narrow)
                                    sText = Replace(sText, Sp󔒑p, "@")
                                Case ӂ肪ȃTCY.SpJ^Ji
                                    sText = StrConv(sText, VbStrConv.Katakana)
                                Case ӂ肪ȃTCY.pJ^Ji
                                    sText = Replace(sText, "@", Sp󔒑p)
                                    sText = StrConv(sText, VbStrConv.Katakana)
                                    sText = StrConv(sText, VbStrConv.Narrow)
                                    sText = Replace(sText, Sp󔒑p, "@")
                            End Select

                            If Not bʒu Then WriteByte(bw, A, X, FURIGANA_SEP_3, FURIGANA_SEP_4)
                            If bHTML Then WriteString(A, X, 0, HTML_FURIGANA_L, True)
                            If Not bʒu Then WriteString(A, X, 0, sӂ肪ȍ, True)
                            WriteString(A, X, 0, sText, True)
                            If Not bʒu Then WriteString(A, X, 0, sӂ肪ȉE, True)
                            If bHTML Then WriteString(A, X, 0, HTML_FURIGANA_R, True)
                            'If Not bʒu Then WriteByte(bw, A, X, FURIGANA_SEP_3, FURIGANA_SEP_4)
                            If bʒu Then
                                If Strings.InStr(sText, vbNewLine) = 0 Then WriteByte(bw, A, X, FURIGANA_SEP_3, FURIGANA_SEP_4)
                            Else
                                WriteByte(bw, A, X, FURIGANA_SEP_3, FURIGANA_SEP_4)
                            End If

                            'If Not sTmp = "" Then WriteByte(bw, A, X, FURIGANA_SEP_3, FURIGANA_SEP_4)
                            'sText = System.Text.Encoding.GetEncoding(R[h.EUC).GetString(ӂ肪ȈȊOf[^)
                            'sText = Replace(sText, vbNullChar, "")
                            'sText = Replace(sText, vbCr, "")
                            'sText = Replace(sText, vbLf, "")
                            'sText = Replace(sText, sӂ肪ȍ, "")
                            'sText = Replace(sText, sӂ肪ȉE, "")
                            'ReDim ӂ肪ȈȊOf[^(0)
                            ''MsgBox(sText)
                            'If Not Trim(sText) = "" Then    'ӂ肪ȈȊOłȂ
                            '    WriteByte(bw, A, X, FURIGANA_SEP_3, FURIGANA_SEP_4)
                            'End If
                            'bӂ肪ȏo͒ = True
                            'WriteString(A, X, 0, sӂ肪ȍ, True)
                            'SZ = TCY.^
                            'SZ_WK = SZ
                            'Exit Sub
                        End If
                    End If
                End If
            End If
        End If
        SZ = SZ_NEW
        SZ_WK = SZ

        Select Case SZ_NEW
            Case TCY.^
                WriteLog(A, X, , , , "^")
            Case TCY.^
                WriteLog(A, X, , , , "^")
            Case TCY.W
                WriteLog(A, X, , , , "W")
            Case TCY.{p
                WriteLog(A, X, X2, , , "TCY")
        End Select
    End Sub

    Private Function Writef[^(ByVal X As Byte, Optional ByVal bs`FbN As Boolean = False) As Boolean
        Dim Len As Integer
        Dim I As Integer
        If bӂ肪ȏo Then
            Len = ӂ肪ȃf[^.Length - 1
            ReDim Preserve ӂ肪ȃf[^(Len + 1)
            ӂ肪ȃf[^(Len) = X
            Return False
        Else
            'Len = UBound(f[^)
            'ReDim Preserve f[^(Len + 1)
            If Lenf[^ > f[^_NEXT_ADD Then
                f[^_NEXT_ADD = f[^_NEXT_ADD + f[^_ADD
                ReDim Preserve f[^(f[^_NEXT_ADD)
            End If
            f[^(Lenf[^) = X
            Lenf[^ = Lenf[^ + 1
            If Not bs`FbN Then
                Lenf[^s = Lenf[^
            End If
            If Not bӂ肪ȏo͒ Then
                Len = ӂ肪ȈȊOf[^.Length - 1 'UBound(ӂ肪ȈȊOf[^)
                ReDim Preserve ӂ肪ȈȊOf[^(Len)
                ӂ肪ȈȊOf[^(Len) = X
            End If
            Return True
        End If
    End Function

    Private Function WriteCSIf[^(ByVal X As Byte) As Boolean
        Dim Len As Integer
        Dim I As Integer
        Len = UBound(CSIf[^)
        ReDim Preserve CSIf[^(Len + 1)
        CSIf[^(Len) = X
        Return False
    End Function

    Private Function SetMacro(ByVal X As Byte) As Boolean
        'Debug.WriteLine(Hex(X))
        Select Case X
            Case &H60
                G0 = I[.
                G1 = I[.p
                G2 = I[.Ђ炪
            Case &H61
                G0 = I[.
                G1 = I[.J^Ji
                G2 = I[.Ђ炪
            Case &H62
                G0 = I[.
                G1 = I[.DRCS_1
                G2 = I[.Ђ炪
            Case &H63
                G0 = I[.MosaicA
                G1 = I[.MosaicC
                G2 = I[.MosaicD
            Case &H64
                G0 = I[.MosaicA
                G1 = I[.MosaicB
                G2 = I[.MosaicD
            Case &H65
                G0 = I[.MosaicA
                G1 = I[.DRCS_1
                G2 = I[.MosaicD
            Case &H66
                G0 = I[.DRCS_1
                G1 = I[.DRCS_2
                G2 = I[.DRCS_3
            Case &H67
                G0 = I[.DRCS_4
                G1 = I[.DRCS_5
                G2 = I[.DRCS_6
            Case &H68
                G0 = I[.DRCS_7
                G1 = I[.DRCS_8
                G2 = I[.DRCS_9
            Case &H69
                G0 = I[.DRCS_10
                G1 = I[.DRCS_11
                G2 = I[.DRCS_12
            Case &H6A
                G0 = I[.DRCS_13
                G1 = I[.DRCS_14
                G2 = I[.DRCS_15
            Case &H6B
                G0 = I[.
                G1 = I[.DRCS_2
                G2 = I[.Ђ炪
            Case &H6C
                G0 = I[.
                G1 = I[.DRCS_3
                G2 = I[.Ђ炪
            Case &H6D
                G0 = I[.
                G1 = I[.DRCS_4
                G2 = I[.Ђ炪
            Case &H6E
                G0 = I[.J^Ji
                G1 = I[.Ђ炪
                G2 = I[.p
            Case &H6F
                G0 = I[.p
                G1 = I[.MosaicA
                G2 = I[.DRCS_1
        End Select
        G3 = I[.MACRO
        GL = Ăяo.G0
        GR = Ăяo.G2
    End Function

    Public Function SetR[h(ByVal sText As String)
        Select Case sText
            Case "VtgJIS"
                no̓R[h = R[h.VtgJIS
            Case "EUC"
                no̓R[h = R[h.EUC
            Case "UTF-16 LE"
                no̓R[h = R[h.UTF_16LE
            Case "UTF-16 BE"
                no̓R[h = R[h.UTF_16BE
            Case "UTF-8"
                no̓R[h = R[h.UTF_8
            Case "UTF-7"
                no̓R[h = R[h.UTF_7
            Case Else
                no̓R[h = R[h.VtgJIS
        End Select
    End Function

    Public Function Setӂ肪ȃTCY(ByVal sText As String)
        Select Case sText
            Case "Sp"
                nӂ肪ȃTCY = ӂ肪ȃTCY.Sp
            Case "p(ꕔ)"
                nӂ肪ȃTCY = ӂ肪ȃTCY.p
            Case "SpJ^Ji"
                nӂ肪ȃTCY = ӂ肪ȃTCY.SpJ^Ji
            Case "p"
                nӂ肪ȃTCY = ӂ肪ȃTCY.pJ^Ji
            Case Else
                nӂ肪ȃTCY = ӂ肪ȃTCY.Sp
        End Select
    End Function

    Public Function J[o(ByVal A As Integer, ByVal X As Byte)
        If Not (bHTML And bJ[) Then Exit Function
        'If SZ = TCY.^ Then Exit Function

        Dim s, sC As String
        s = HTML_COLOR_L1

        If bJX^J[ Then
            sC = sCol(X Mod &H80)
        Else
            Select Case X
                Case &H80 'BKF
                    sC = sColBK
                Case &H81 'RDF
                    sC = sColRD
                Case &H82 'GRF
                    sC = sColGR
                Case &H83 'YLF
                    sC = sColYL
                Case &H84 'BLF
                    sC = sColBL
                Case &H85 'MGF
                    sC = sColMG
                Case &H86 'CNF
                    sC = sColCN
                Case &H87 'WHF
                    sC = sColWH
            End Select
        End If
        s = HTML_COLOR_L1 & sC & HTML_COLOR_L2
        WriteString(A, X, 0, s, True, True)
        'bJ[o = True
    End Function

    Public Function HLCo(ByVal A As Integer, ByVal X As Byte, ByVal X2 As Byte)

        WriteLog(A, X, X2, , , "HLC")
        If Not bHLC Then Exit Function

        Dim s As String

        Select Case X2
            Case &H4D
                s = HTML_HLC_L
            Case &H47
                s = HTML_HLC_R
            Case Else
                Exit Function
        End Select

        WriteString(A, X, X2, s, False, True)

    End Function

    Public Sub SetHLCText()

        Dim L, R As String
        L = ""
        R = ""

        If bHLC Then
            If bHTML Then
                If bJ[ Then
                    L = HTML_HLC_COL3 & sCol(10) & HTML_HLC_COL4 & sCol(9) & HTML_HLC_COL5
                    R = HTML_HLC_COL6
                    If bHLCg Then
                        L = HTML_HLC_COL1 & sCol(9) & HTML_HLC_COL2 & L
                        R = R & HTML_HLC_2
                    End If
                Else
                    If bHLCg Then
                        L = HTML_HLC_1
                        R = HTML_HLC_2
                    Else
                        L = sHLC
                        R = sHLCE
                    End If
                End If
            Else
                L = sHLC
                R = sHLCE
            End If
        End If

        HTML_HLC_L = L
        HTML_HLC_R = R
    End Sub

    Public Function ReplaceHLCText(ByVal s As String) As String
        If bHLC Then
            If bHTML Then
                If bJ[ Then
                    s = HTML_HEAD_COLOR & Replace(s, HTML_HLC_COL3, HTML_HLC_COL3_OK, Strings.Len(HTML_HEAD_COLOR) + 1)
                    s = HTML_HEAD_COLOR & Replace(s, HTML_HLC_COL4, HTML_HLC_COL4_OK, Strings.Len(HTML_HEAD_COLOR) + 1)
                    If bHLCg Then
                        s = HTML_HEAD_COLOR & Replace(s, HTML_HLC_COL1, HTML_HLC_COL1_OK, Strings.Len(HTML_HEAD_COLOR) + 1)
                    End If
                Else
                    If bHLCg Then
                        s = HTML_HEAD_COLOR & Replace(s, HTML_HLC_1, HTML_HLC_1_OK, Strings.Len(HTML_HEAD_COLOR) + 1)
                    End If
                End If
            End If
        End If

        Return s
    End Function

    Public Sub LoadARIBGaijiHTML()
        Select Case no̓R[h
            Case common.R[h.EUC, common.R[h.VtgJIS
                LoadARIBGaiji()
            Case Else
                If sFontSelectHTML = WIN_DVD_FONT Or sFontSelectHTML = RICHO_FONT Then
                    LoadARIBGaiji(WIN_DVD_GAIJI_INI)
                Else
                    LoadARIBGaiji(UNICODE_GAIJI_INI)
                End If
        End Select
    End Sub
End Module
